/*-------------------------------------------------------------------------
    Simple distributed database engine
    Copyright (C) 2012  Sylvain Hallé

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 -------------------------------------------------------------------------*/
package ca.uqac.dim.turtledb;

public abstract class Communicator implements Runnable
{
  public abstract QueryProcessor getQueryProcessor(Relation query);
  
  public abstract QueryProcessor getQueryProcessor(QueryPlan plan);
  
  public class QueryExecutionException extends Exception
  {
    /**
     * Dummy UID
     */
    private static final long serialVersionUID = 1L;
    
    protected String m_message = "";
    
    public QueryExecutionException(String message)
    {
      super();
      m_message = message;
    }
    
  }
}
